
<app-gen-modal 
    [(isVisible)]="isVisible" 
    [bodyTemplate]="bodyTemplate" 
    [headerTemplate]="headerTemplate"
    [headerBannerTemplate]="headerBannerTemplate"
    [footerTemplate]="footerTemplate"
    ></app-gen-modal>

<ng-template #bodyTemplate>
        
        <div *ngIf="isLoading; else notLoadingBlock" class="d-flex justify-content-center">
            <div class="spinner-border" role="status">
            
            </div>
        </div>
        <ng-template #notLoadingBlock>
            <ng-container *ngIf="!isEdit; else editBlock">
                <h4 class="card-title">{{todo.name}}</h4>
                <p class="card-text">{{todo.description}}</p>
                
                
                <p>
                    <b>Progression: </b>{{todo.progression | number: '1.0-2'}} % <br />
                    <b>Date de livraison: </b>{{todo.dateLivraison ? (todo.dateLivraison | date: 'dd/MM/yyyy') : '--/--/--'}}
                </p>
                <!-- <a href="#" class="btn btn-outline-primary">Go somewhere</a> -->            
            </ng-container>
               
            <ng-template #editBlock>
                <form (ngSubmit)="updateTodo()" class="form form-vertical" [formGroup]="form">
                    <div class="row">
                        <div class="col-12">
                            <div class="mb-1">
                                <label class="form-label" for="first-name-column">Intitulé</label>
                                <input type="text" id="first-name-column" class="form-control" placeholder="" formControlName="name" />
                            </div>
                        </div>
                        <div class="col-12">
                            <div class="mb-1">
                                <label class="form-label" for="last-name-column">Description</label>
                                <textarea  id="company-or-client-description" class="form-control" placeholder="" formControlName="description" rows="3" ></textarea>
                            </div>
                        </div>
                        <div class="col-12">
                            <div class="mb-1">
                                <label class="form-label" >Aperçu</label>
                                <input type="file" multiple="true" class="form-control" placeholder="" (change)="onChange($event)" formControlName="apercuFileList" />
                            </div>
                            <ng-container *ngIf="todo.apercu!=null">
                                <div class="file-container">
                                    <div *ngFor="let file of selectedFiles; let i = index" class="file" >
                                      <ng-container >
                                          <img [src]="getSanitizedImageUrl(file)" />
                                          <span (click)="onDelete(i)">X</span>
                                      </ng-container>
                                    </div>
                                  </div>
                            </ng-container>
                        </div>
                        <div class="col-12">
                            <div class="mb-1">
                                <label class="form-label" >Date de livraison</label>
                                <input type="date"  class="form-control" placeholder="" formControlName="dateLivraison" />
                            </div>
                        </div>
                        <div class="col-12" *ngIf="todo.status == todoStatus.inProgress">
                            <div class="mb-1">
                                <label class="form-label" >Progression (%)</label>
                                <input type="number"  class="form-control" placeholder="" formControlName="progression" />
                            </div>
                        </div>
                       
                    </div>
                    <div class="d-flex align-items-center">
                        <app-gen-button [text]="'Enregistrer'" [disabled]="!form.valid" [isLoading]="isUpdatingTodo" (click)="updateTodo()"></app-gen-button>
                        <button class="btn btn-secondary mx-50" (click)="toogleEdit()" ><i class="fa fa-times"></i>&nbsp;Annuler</button>
                    </div>
                </form>
            </ng-template>

            <div class="col-12 mt-1" >
                <h6 class="section-label mt-25">Commentaires</h6>
                <p *ngIf="comments.length == 0">Aucune commentaire</p>
                <div class="card" *ngFor="let comment of comments; let i=index">
                    <div class="card-body">
                        <div class="d-flex align-items-start">
                            <div class="avatar me-75">
                                <img src="{{getAvatarUrl(comment.user.image)}}" width="38" height="38" alt="Avatar" />
                            </div>
                            <div class="author-info">
                                <h6 class="fw-bolder mb-25">{{comment.user._id == me._id ? 'Vous' : comment.user.name}}</h6>
                                <p class="card-text">{{comment.dateComment | date: 'dd/MM/yyyy HH:mm'}}</p>
                                <p class="card-text" *ngIf="comment.contenu">
                                    {{comment.contenu}}
                                </p>
                                <div  *ngIf="comment.fichiers.length > 0" class="d-flex flex-column ">
                                    <ng-container *ngFor="let fichier of comment.fichiers; let j=index">
                                        <img *ngIf="fichier.imageUrl; else notFichierImage" src="{{fichier.imageUrl}}"  class="rounded mt-50" style="max-width: 200px; height: auto;"  />
                                        <ng-template #notFichierImage>
                                            <div class="btn-primary d-flex align-items-center my-file-box mt-50" >
                                                <div class="p-50">
                                                    <i class="fa-solid fa-paperclip"></i>
                                                    <span  class="ms-50 link" (click)="downloadFile(fichier.chemin, fichier.nom)">{{fichier.nom}}</span>
                                                </div>
                                            </div>
                                        </ng-template>
                                    </ng-container>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <form [formGroup]="formComments" class="chat-app-form"  (submit)="comment()" class="mt-1">
        
                    <div  class="d-flex flex-column ">
                        <div class="btn-primary d-flex align-items-center my-file-box mt-50" *ngFor="let fichier of fichiers; let i=index">
                            <div class="p-50">
                                <i class="fa-solid fa-paperclip"></i>
                                <span *ngIf="!fichier.loading" class="ms-50 link" (click)="downloadFile(fichier.chemin, fichier.nom)">{{fichier.nom}}</span>
                                <span *ngIf="fichier.loading" class="ms-50" >{{fichier.nom}}</span>
                            </div>
                            <span *ngIf="fichier.loading" class="spinner-border spinner-border-sm me-50" role="status" aria-hidden="true"></span>
                            <div  *ngIf="!fichier.loading" class="p-50 close" (click)="removeFichier(i)">
                                <i class="fa-solid fa-times"></i>
                            </div>
                            
                
                        </div>
                    </div>
                    <div class="d-flex align-items-center mt-50">
                        <div class="input-group input-group-merge me-1 form-send-message">
                            <span class="speech-to-text input-group-text"><i data-feather="mic" class="cursor-pointer"></i></span>
                            <input type="text" class="form-control message" placeholder="Entrer votre commentaire" formControlName="contenu" />
                            <span class="input-group-text">
                                <label for="attach-doc" class="attachment-icon form-label mb-0">
                                    <i class="fa fa-paperclip cursor-pointer text-secondary" aria-hidden="true"></i>
                                    <input type="file" id="attach-doc" hidden multiple (change)="onFileSelected($event)"/> </label></span>
                        </div>
                        <button type="button" class="btn btn-primary send" (click)="comment()" [style.pointer-events]="form.valid && !isCommenting ? 'auto': 'none' "> 
                            <span *ngIf="isCommenting; else notCommenting" class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
                            <ng-template #notCommenting>
                                <i class="fa fa-paper-plane d-lg-none"></i>
                                <span class="d-none d-lg-block">Envoyer</span>
                            </ng-template>
                        </button>
                    </div>
                </form>
            </div>

        </ng-template>
</ng-template>

<ng-template #headerTemplate>
        <h4 class="modal-title float-start" >Tâche</h4>
        <button *ngIf="!isClient && !isLoading && !isEdit" class="btn btn-primary float-end" (click)="toogleEdit()"><i class="fa fa-edit"></i>Modifier</button>
        <app-gen-button *ngIf="isClient && !isLoading && todo.status == todoStatus.finished" text='<i class="fa fa-check"></i>&nbsp;Valider'  customClass="float-end" [isLoading]="isValidating" (click)="validate()" type="success"></app-gen-button>
</ng-template> 

<ng-template #headerBannerTemplate>
    <ng-container *ngIf="todo!=null && todo.apercu!=null">
        <ng-image-slider class="w-100" [images]="selectedFilesBase64" [animationSpeed]="0.1" [imageSize]="{width: '100%', space:0}" #nav></ng-image-slider>
    </ng-container>
</ng-template> 


<ng-template #footerTemplate>
    <button type="button" class="btn btn-outline-dark" (click)="handleCancel()" >Fermer</button>

    

</ng-template> 




